::
:: Upload a file to a ftp-server every time when it gets modified.
::

@echo off

:: Usage
set /a MISSING=0
if [%1] == [] set /a MISSING += 1
if [%2] == [] set /a MISSING += 1
if [%3] == [] set /a MISSING += 1
if [%4] == [] set /a MISSING += 1
if %MISSING% NEQ 0 (
    echo Usage: upload.bat [file] [ftp-server] [ftp-user] [ftp-password]
    exit /b 1
)

:: Parameters
set FILE = %1
set SERVER = %2
set USER = %3

:: Test whether file exists
if not exist %FILE% (
    echo ERROR: File not found: %FILE%
    exit /b 1
)

:: Check file type
if [%~x1] NEQ [.json] (
    echo ERROR: No *.json file: %FILE%
    exit /b 1
)

:: Settings (Maximal runtime: 10 hours)
set /a PAUSE_TIMER=15
sset /a LOOP_COUNT=60*60*10/PAUSE_TIMER
set LAST_UPLOAD=03.02.2001 04:05
:: set /a LAST_SIZE=0

:: Show parameters
echo #######################
echo ### File=%FILE%
echo ### Server=%SERVER%
echo ### User=%USER%
:: echo ### Password=%4 :: Skipped due to security reason
echo ### Pause=%PAUSE_TIMER% sec
echo #######################

:: Create temporary ftp script
( echo %USER%
  echo %4
  echo asc
  echo put %FILE%
  echo quit
) > upload-bat.ftp

:loopstart

    :: Test whether file exists
    if not exist %FILE% (
        echo ERROR: File does not exist: %FILE%
        exit /b 1
    )

    :: Get file properties
    set lastModified=%~t1
    set /a size=%~z1
    :: echo Size: Date: %lastModified% ? %LAST_UPLOAD% Size: %size% ? %LAST_SIZE%

    :: Test whether size is too large (> 1MB)
    if %size% GTR 1000000 (
        echo ERROR File is too large: %size%
        exit /b 1
    )
    :: if %LAST_SIZE% NEQ %size% goto upload

    :: TODO [9] %~t1 only returns hour:minute

    :: Test whether modification date is newer
    set /a M=1%lastModified:~6,4%
    set /a U=1%LAST_UPLOAD:~6,4%
    :: echo Year:   %M% ? %U%
    if %U% LSS %M% (goto upload)
    if %U% GTR %M% (goto pause)

    set /a M=1%lastModified:~3,2%
    set /a U=1%LAST_UPLOAD:~3,2%
    :: echo Month:  %M% ? %U%
    if %U% LSS %M% (goto upload)
    if %U% GTR %M% (goto pause)

    set /a M=1%lastModified:~0,2%
    set /a U=1%LAST_UPLOAD:~0,2%
    :: echo Day:    %M% ? %U%
    if %U% LSS %M% (goto upload)
    if %U% GTR %M% (goto pause)

    set /a M=1%lastModified:~11,2%
    set /a U=1%LAST_UPLOAD:~11,2%
    :: echo Hour:   %M% ? %U%
    if %U% LSS %M% (goto upload)
    if %U% GTR %M% (goto pause)

    set /a M=1%lastModified:~-2%
    set /a U=1%LAST_UPLOAD:~-2%
    :: echo Minute: %M% ? %U%
    if %U% GEQ %M% (goto pause)

    :upload
    :: Upload file via ftp
    echo Upload file on %lastModified%
    ftp -i -v -s:upload-bat.ftp %SERVER% > NUL

    :: Keep upload time
    set LAST_UPLOAD=%lastModified%
    :: set LAST_SIZE=%size%

    :: Pause
    :pause
    echo | set /p dummy="."
    timeout /nobreak /t %PAUSE_TIMER% > NUL

    set /a LOOP_COUNT -= 1
if %LOOP_COUNT% GTR 0 goto loopstart

:: Delete ftp script
del upload-bat.ftp /q >nul

exit /b %ERRORLEVEL%
